#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "wireR.h"

double r=0; 
int fileflag = 0;
double distance(double x1, double x2, double y1, double y2)
{
	return sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
}

void perpendicular(double x1, double x2, double x3, double y1, double y2, double y3,double *x, double *y)
{
    // find the vertical point of (x1,y1) on the line containing points (x2,y2) and (x3,y3)
	double k,k1;
	if(x3==x2) //vertical
	{
		*x=x2;
		*y=y1;
	}
	else if (y2==y3) //horizontal
	{
		*x=x1;
		*y=y2;
	}
	else
	{
		k=(y3-y2)/(x3-x2); //slope
		k1=-1/k;
		*x=(k1*x1-k*x2-y1+y2)/(k1-k);
		*y=k1*(*x-x1)+y1;
	}
}

double res()
{
    //return the resistance of the Res2d simulation
	FILE *fp;  
	char s[80];
	double R;
	int e;
	int flag;
	fp=fopen("a.txt","r");
	fscanf(fp,"%s",s);
	/*zcs.
	if(fscanf(fp,"%s",s)!=1){
	  printf("error\n");
	  exit (1);
	}
	*/
	while(strcmp(s,"R:Omega"))
		fscanf(fp,"%s",s);
	//fscanf(fp,"1e%d",&e);
	
	getc(fp);getc(fp);getc(fp);getc(fp);
	fscanf(fp,"%d",&e);
	/*zcs.while(strcmp(s,"res"))
		if(fscanf(fp,"%s",s)!=1)
	  		printf("error\n");
	printf("%s\n",s);
	getc(fp);getc(fp);getc(fp);//getc(fp);
	fscanf(fp,"%d",&e);
	*/
	//printf("e=%d\n",e);
	/*zcs.
	fscanf(fp,"%s",s);fscanf(fp,"%s",s);fscanf(fp,"%s",s);fscanf(fp,"%s",s);
	fscanf(fp,"%lf",s);
	printf("s=%lf\n",s);
	fscanf(fp,"%lf",&R);
	*/
	while(strcmp(s,"res"))
		fscanf(fp,"%s",s);
	fscanf(fp," = %lf",&R);
	/*zcs
	if(fscanf(fp," = %lf",&R)!=1){
	  printf("error\n");
	  exit (1);
	}
	*/
	//printf("R=%lf\n",R);
    //if(R<1&&R1>0)
    //    R=R1;
//zcs.20140507
//printf("e=%d\n",e);
    //printf("R=%lf,exp=%lf\n",R,exp10(e));

	R=R*exp10(e);  
//printf("111R=%lf\n",R);
    fclose(fp);
	return R;
}

void longparallel(double *graph[2],double port[2][4], int length)
{
	double *g[2],*a,*k,x[4],y[4],newx[4],newy[4],d,di,dj,R,lastx[2],lasty[2],*px,*py;
	int i=0,j=0,p,m=0,flag[4],sign,count=0,lasti,lastj,e;
	char* s;
	int flag1;
    char Case[10]="Case0.r2d";
	void convex(double *g[2], int length, FILE *fp);
	void perpendicular(double x1, double x2, double x3, double y1, double y2, double y3, double *x, double *y);
	FILE *fp,*fp1;
	fp=fopen("Case.r2d","w");
    if(fileflag)
        fp1=fopen(Case,"w");
    Case[4]++;
    //Res2d file
    fprintf(fp,"begin\n");
    if(fileflag)
        fprintf(fp1,"begin\n");
    for(i=0;i<length-1;i++)
        if(graph[0][i]==port[0][2]&&graph[1][i]==port[1][2])
            p=i;
	a=(double *)malloc(sizeof(double)*length);    //a[i] indicates the angle of edge i 
	k=(double *)malloc(sizeof(double)*length);    //k[i] indicates the slope of edge i
	px=(double *)malloc(sizeof(double));
	py=(double *)malloc(sizeof(double));
	for(i=0;i<length-1;i++)
		if (graph[0][i+1]-graph[0][i]==0)
			a[i]=90;
		else
		{
			k[i]=(graph[1][i+1]-graph[1][i])/(graph[0][i+1]-graph[0][i]);
			a[i]=atan((graph[1][i+1]-graph[1][i])/(graph[0][i+1]-graph[0][i]))*180/3.1415926;
		}
	if(graph[0][0]-graph[0][length-1]==0)
		a[length-1]=90;
	else
		a[length-1]=atan((graph[1][0]-graph[1][length-1])/(graph[0][0]-graph[0][length-1]))*180/3.1415926;
	lastj=length-1; 
    //for(i=0;i<length;i++)
    //   printf("%f, ", a[i]);
	//printf("p=%d,lastj=%d\n",p,lastj);
  	for(i=0;i<p;i++){
		for(j=p+1; j<lastj;j++)
		{
			if(fabs(a[i]-a[j])<ANGLEMAX||fabs(a[i]-a[j])>180-ANGLEMAX)      //parallel edges
			{
                perpendicular(graph[0][i],graph[0][j],graph[0][j+1],graph[1][i],graph[1][j],graph[1][j+1],px,py);
				x[0]=*px; y[0]=*py;
				perpendicular(graph[0][i+1],graph[0][j],graph[0][j+1],graph[1][i+1],graph[1][j],graph[1][j+1],px,py);
				x[1]=*px; y[1]=*py;				
				perpendicular(graph[0][j],graph[0][i],graph[0][i+1],graph[1][j],graph[1][i],graph[1][i+1],px,py);
				x[2]=*px; y[2]=*py;
				perpendicular(graph[0][j+1],graph[0][i],graph[0][i+1],graph[1][j+1],graph[1][i],graph[1][i+1],px,py);
				x[3]=*px; y[3]=*py;                
				flag[0]=(x[0]-graph[0][j])*(x[0]-graph[0][j+1])<=0&&(y[0]-graph[1][j])*(y[0]-graph[1][j+1])<=0;
				flag[1]=(x[1]-graph[0][j])*(x[1]-graph[0][j+1])<=0&&(y[1]-graph[1][j])*(y[1]-graph[1][j+1])<=0;   
				flag[2]=(x[2]-graph[0][i])*(x[2]-graph[0][i+1])<=0&&(y[2]-graph[1][i])*(y[2]-graph[1][i+1])<=0;   
				flag[3]=(x[3]-graph[0][i])*(x[3]-graph[0][i+1])<=0&&(y[3]-graph[1][i])*(y[3]-graph[1][i+1])<=0;   
                //flag[i] indicates whether (x[i],y[i]) is on the opposite segment 
                d=distance(graph[0][i],x[0],graph[1][i], y[0]);
				di=distance(graph[0][i],graph[0][i+1],graph[1][i],graph[1][i+1]);
				dj=distance(graph[0][j],graph[0][j+1],graph[1][j],graph[1][j+1]);
                
                if(LONG*d>di||LONG*d>dj||d==0)
					continue;
                //printf("%d,%d,%lf,%lf,%lf\n",i,j,d,di,dj);
				if(flag[0]+flag[3]==0||flag[1]+flag[2]==0)
                    continue; //no overlap
                if(flag[0]&&flag[2])
				{
					di=distance(x[2],graph[0][i],y[2],graph[1][i]);  //length of the overlap
					dj=distance(x[0],graph[0][j],y[0],graph[1][j]);
					if(LONG*d<di&&LONG*d<dj)      //long parallel
					{            
						if (graph[0][i+1]==graph[0][i])     //slope is infinity
						{
							if(graph[1][i+1]-graph[1][i]>0)
								sign=1;
							else if(graph[1][i+1]-graph[1][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=x[0]; newx[1]=x[1]; newx[2]=x[2]; newx[3]=x[3];
							newy[0]=y[0]+CORNER*sign*d; newy[1]=graph[1][j]-CORNER*sign*d;newy[2]=y[2]-CORNER*sign*d; newy[3]=graph[1][i]+CORNER*sign*d;
						}
						else
						{
							if(graph[0][i+1]-graph[0][i]>0)
								sign=1;
							else if(graph[0][i+1]-graph[0][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=x[0]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[1]=graph[0][j]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[2]=x[2]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[3]=graph[0][i]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newy[0]=k[j]*(newx[0]-graph[0][j])+graph[1][j];
							newy[1]=k[j]*(newx[1]-graph[0][j])+graph[1][j];
							newy[2]=k[i]*(newx[2]-graph[0][i])+graph[1][i];
							newy[3]=k[i]*(newx[3]-graph[0][i])+graph[1][i];
                            //newx,newy indicate the coordinate of the partitioning points
						}		
					}
				}
				else if(flag[0]&&flag[1])
				{
					di=distance(x[1],graph[0][j+1],y[1],graph[1][j+1]);
					dj=distance(x[0],graph[0][j],y[0],graph[1][j]);		
					if(LONG*d<di&&LONG*d<dj)
					{                        
						if (graph[0][i+1]==graph[0][i])
						{
							if(graph[1][i+1]-graph[1][i]>0)
								sign=1;
							else if(graph[1][i+1]-graph[1][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=x[0]; newx[1]=x[1]; newx[2]=x[2]; newx[3]=x[3];
							newy[0]=y[0]+CORNER*sign*d; newy[1]=y[1]-CORNER*sign*d;newy[2]=graph[1][i+1]-CORNER*sign*d; newy[3]=graph[1][i]+CORNER*sign*d;
						}
						else
						{
							if(graph[0][i+1]-graph[0][i]>0)
								sign=1;
							else if(graph[0][i+1]-graph[0][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=x[0]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[1]=x[1]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[2]=graph[0][i+1]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[3]=graph[0][i]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newy[0]=k[j]*(newx[0]-graph[0][j])+graph[1][j];
							newy[1]=k[j]*(newx[1]-graph[0][j])+graph[1][j];
							newy[2]=k[i]*(newx[2]-graph[0][i])+graph[1][i];
							newy[3]=k[i]*(newx[3]-graph[0][i])+graph[1][i];							
						}
						
					}
				}
				else if(flag[1]&&flag[3])
				{                    
					di=distance(x[2],graph[0][i],y[2],graph[1][i]);
					dj=distance(x[0],graph[0][j],y[0],graph[1][j]);
                    
					if(LONG*d<di&&LONG*d<dj)
					{
						if (graph[0][i+1]==graph[0][i])
						{
                            
							if(graph[1][i+1]-graph[1][i]>0)
								sign=1;
							else if(graph[1][i+1]-graph[1][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=x[0]; newx[1]=x[1]; newx[2]=x[2]; newx[3]=x[3];
							newy[0]=graph[1][j+1]+CORNER*sign*d; newy[1]=y[1]-CORNER*sign*d;newy[2]=graph[1][i+1]-CORNER*sign*d; newy[3]=y[3]+CORNER*sign*d;
						}
						else
						{
							if(graph[0][i+1]-graph[0][i]>0)
								sign=1;
							else if(graph[0][i+1]-graph[0][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=graph[0][j+1]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[1]=x[1]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[2]=graph[0][i+1]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[3]=x[3]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newy[0]=k[j]*(newx[0]-graph[0][j])+graph[1][j];
							newy[1]=k[j]*(newx[1]-graph[0][j])+graph[1][j];
							newy[2]=k[i]*(newx[2]-graph[0][i])+graph[1][i];
							newy[3]=k[i]*(newx[3]-graph[0][i])+graph[1][i];
                           			
                        }
						
					}
				}
				else if(flag[2]&&flag[3])
                {
					di=distance(x[2],graph[0][i],y[2],graph[1][i]);
					dj=distance(x[0],graph[0][j],y[0],graph[1][j]);
					if(LONG*d<di&&LONG*d<dj)
					{
						if (graph[0][i+1]==graph[0][i])
						{
							if(graph[1][i+1]-graph[1][i]>0)
								sign=1;
							else if(graph[1][i+1]-graph[1][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=x[0]; newx[1]=x[1]; newx[2]=x[2]; newx[3]=x[3];
							newy[0]=graph[1][j+1]+CORNER*sign*d; newy[1]=graph[1][j]-CORNER*sign*d;newy[2]=y[2]-CORNER*sign*d; newy[3]=y[3]+CORNER*sign*d;
						}
						else
						{
							if(graph[0][i+1]-graph[0][i]>0)
								sign=1;
							else if(graph[0][i+1]-graph[0][i]==0)
								sign=0;
							else
								sign=-1;
							newx[0]=graph[0][j+1]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[1]=graph[0][j]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[2]=x[2]-CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newx[3]=x[3]+CORNER*sign*d/sqrt(1+k[i]*k[i]);
							newy[0]=k[j]*(newx[0]-graph[0][j])+graph[1][j];
							newy[1]=k[j]*(newx[1]-graph[0][j])+graph[1][j];
							newy[2]=k[i]*(newx[2]-graph[0][i])+graph[1][i];
							newy[3]=k[i]*(newx[3]-graph[0][i])+graph[1][i];
						}						
					}
				}
                if(LONG*d<di&&LONG*d<dj) //long parallel edges found
                {                    
                    if(!count) // the first long parallel edges
                    {   
                        g[0]=(double *)malloc(sizeof(double)*(i+length-j+2));
                        g[1]=(double *)malloc(sizeof(double)*(i+length-j+2));
                        for(m=0;m<=i;m++)
                        {
                            g[0][m]=graph[0][m];
                            g[1][m]=graph[1][m];
                        }
                        g[0][i+1]=newx[3];
                        g[1][i+1]=newy[3];
                        g[0][i+2]=newx[0];
                        g[1][i+2]=newy[0];
                        for(m=j+1;m<length;m++)
                        {
                            g[0][m-j+2+i]=graph[0][m];
                            g[1][m-j+2+i]=graph[1][m];
                        }	
                        // printf("pass\n");
                        //for(m=0;m<i+length-j+2;m++)
                        //   printf("%lf, %lf\n", g[0][m],g[1][m]);
                        convex(g,i+length-j+2,fp);
                        if(fileflag)
                            convex(g,i+length-j+2,fp1);
                        // printf("pass convex\n"); 
                        free(g[0]);free(g[1]);
                        //Res2d file
                        fprintf(fp, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",port[0][0],port[1][0],port[0][1],port[1][1]);
                        fprintf(fp, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",newx[3],newy[3],newx[0],newy[0]);
                        fclose(fp);
                        if(fileflag)
                        {
                            fprintf(fp1, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",port[0][0],port[1][0],port[0][1],port[1][1]);
                            fprintf(fp1, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",newx[3],newy[3],newx[0],newy[0]);
                            fclose(fp1);
                        }
//Res2d simulation
                        flag1=system("./B2D -a Case.r2d>a.txt");
                        if(flag1!=0)
                            exit(0);
                        //printf("call B2D sucessuflly!\n");
                        R=res();
                        r+=R;	
                        printf("Res=%lf\n",R);	
                        fp=fopen("Case.r2d","w");
                        if(fileflag)
                            fp1=fopen(Case,"w");
                        Case[4]++;
                        fprintf(fp,"begin\n");
                        if(fileflag)
                            fprintf(fp1,"begin\n");
                    }
                    else // not the first parallel edges
                    {
                        g[0]=(double *)malloc(sizeof(double)*(i-lasti-j+lastj+4));
                        g[1]=(double *)malloc(sizeof(double)*(i-lasti-j+lastj+4));
                        g[0][0]=lastx[0];
                        g[1][0]=lasty[0];
                        for(m=lasti+1;m<=i;m++)
                        {
                            g[0][m-lasti]=graph[0][m];
                            g[1][m-lasti]=graph[1][m];
                        }
                        g[0][i-lasti+1]=newx[3];
                        g[1][i-lasti+1]=newy[3];
                        g[0][i-lasti+2]=newx[0];
                        g[1][i-lasti+2]=newy[0];
                        for(m=j+1;m<=lastj;m++)
                        {
                            g[0][m+2+i-lasti-j]=graph[0][m];
                            g[1][m+2+i-lasti-j]=graph[1][m];
                        }
                        g[0][i-lasti-j+lastj+3]=lastx[1];
                        g[1][i-lasti-j+lastj+3]=lasty[1];
                        //printf("pass, %d\n",i-lasti-j+lastj+4);
                        convex(g,i-lasti-j+lastj+4,fp);
                        if(fileflag)
                            convex(g,i-lasti-j+lastj+4,fp1);
                        free(g[0]);free(g[1]);
                        //Res2d file
                        fprintf(fp, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",lastx[1],lasty[1],lastx[0],lasty[0]);
                        fprintf(fp, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",newx[3],newy[3],newx[0],newy[0]);
                        fclose(fp);
                        if(fileflag)
                        {
                            fprintf(fp1, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",lastx[1],lasty[1],lastx[0],lasty[0]);
                            fprintf(fp1, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",newx[3],newy[3],newx[0],newy[0]);
                            fclose(fp1);   
                        }
                        //Res2d simulation
                        flag1=system("./B2D -a Case.r2d>a.txt");
                        if(flag1!=0)
                            exit(0);
                        //printf("call B2D sucessuflly!\n");
                        R=res();
                        r+=R;
                        printf("Res=%lf\n",R);	
                        fp=fopen("Case.r2d","w");
                        if(fileflag)
                            fp1=fopen(Case,"w");
                        Case[4]++;
                        fprintf(fp,"begin\n");
                        if(fileflag)
                            fprintf(fp1,"begin\n");
                    }
                    lasti=i;lastj=j;
                    lastx[0]=newx[2];lastx[1]=newx[1];
                    lasty[0]=newy[2];lasty[1]=newy[1];
                    count++;
                    R=2*distance(newx[0],newx[1],newy[0],newy[1])/(distance(newx[0],newx[3],newy[0],newy[3])+distance(newx[1],newx[2],newy[1],newy[2]));
                    r+=R;
                    if(fabs(a[i]-a[j])>ANGLEMIN||fabs(a[i]-a[j])<180-ANGLEMIN&&fabs(a[i]-a[j])>180-ANGLEMAX)                    
                        printf("Warning, long trapezoid. Long trapezoid=%lf\n",R);
                    else
                        printf("Longparallel=%lf\n",R);                                        
                }
            }
        }
	}
    //printf("pass final%d\n", count);
    //the final part
    if(!count) //no longparallel edges in the polygon
	{
        //printf("pass\n");
		convex(graph,length,fp);
        if(fileflag)
            convex(graph,length,fp1);
        //printf("pass convex\n");.
        //Res2d file
		fprintf(fp, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",port[0][0],port[1][0],port[0][1],port[1][1]);
		fprintf(fp, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",port[0][2],port[1][2],port[0][3],port[1][3]);
		fclose(fp);
        if(fileflag)
        {
            fprintf(fp1, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",port[0][0],port[1][0],port[0][1],port[1][1]);
            fprintf(fp1, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",port[0][2],port[1][2],port[0][3],port[1][3]);
            fclose(fp1);
        }
        //Res2d simulation
		flag1=system("./B2D -a Case.r2d>a.txt");
		if(flag1!=0)
			exit(0);
		//printf("call Res2d sucessuflly!\n");
		r=res();
		printf("Res=%lf\n",r);
	}
    else // longparallel edges in the polygon
	{
        g[0]=(double *)malloc(sizeof(double)*(lastj-lasti+2));
		g[1]=(double *)malloc(sizeof(double)*(lastj-lasti+2));
		g[0][0]=lastx[0];
		g[1][0]=lasty[0];
		for(m=lasti+1;m<=lastj;m++)
		{
			g[0][m-lasti]=graph[0][m];
			g[1][m-lasti]=graph[1][m];
		}
		g[0][lastj-lasti+1]=lastx[1];
		g[1][lastj-lasti+1]=lasty[1];
        //printf("pass\n");
        convex(g,lastj-lasti+2,fp);
        if(fileflag)
            convex(g,lastj-lasti+2,fp1);
        //printf("pass convex\n");
		free(g[0]);free(g[1]);
        //Res2d file
		fprintf(fp, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",lastx[1],lasty[1],lastx[0],lasty[0]);
		fprintf(fp, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",port[0][2],port[1][2],port[0][3],port[1][3]);
		fclose(fp);
        if(fileflag)
        {
            fprintf(fp1, "  poly c1;volt;(%.3f,%.3f),(%.3f,%.3f)\n",lastx[1],lasty[1],lastx[0],lasty[0]);
            fprintf(fp1, "  poly c2;volt;(%.3f,%.3f),(%.3f,%.3f)\nresi\nend",port[0][2],port[1][2],port[0][3],port[1][3]);
            fclose(fp1);
        }
        //Res2d simulation
		flag1=system("./B2D -a Case.r2d>a.txt");
		if(flag1!=0)
			exit(0);
		//printf("call Res2d sucessuflly!\n");
		R=res();
        r+=R;
		printf("Res=%lf\n",R);		
	}	
    	system("rm Case.r2d a.txt");
	free(a);free(k);free(px);free(py);
}

int intersect(double x1,double x2,double x3, double x4,double y1,double y2,double y3,double y4)
{
    double x, y, k1, k2;
    //the intersection point is (x,y)
    if(x1==x2)
    {
        if(x3==x4) //parallel
            return 0;
        else 
        {
            x=x1;
            y=(y3-y4)/(x3-x4)*(x-x3)+y3;
            if(x1<x3&&x1<x4 || x1>x3&&x1>x4)
                return 0;
            if(y<=y2&&y>=y1||y>=y2&&y<=y1)
                return 1;
            else 
                return 0;
        }
    }
    else if(x3==x4)
    {
        x=x3;
        y=(y1-y2)/(x1-x2)*(x-x1)+y1;
        if(x1<x3&&x2<x3 || x1>x3&&x2>x3)
            return 0;
        if(y<=y3&&y>=y4||y>=y3&&y<=y4 )
            return 1;
        else
            return 0;
    }
    else
    {
        k1=(y2-y1)/(x2-x1);
        k2=(y4-y3)/(x4-x3);
        
        if(k1==k2) //parallel
            return 0;               
        x=(k1*x1-k2*x3-y1+y3)/(k1-k2);
        //printf("%lf. %lf, %lf ",k1,k2,x);
        if((x<=x1&&x>=x2||x<=x2&&x>=x1)&&(x<=x3&&x>=x4||x<=x4&&x>=x3))
            return 1;
        else
            return 0;
    }                
}


void convex(double *g[2], int length, FILE *fp)
{
    //find the concave vertices in the graph, partition the graph, and output it into file
	int i=0,count=0,j,l,min,max,*y,point=0,flag;
	double c,z,*g1[2],*G[2],z1,z2,v1[2]={0,0},v2[2]={0,0},v[2]={0,0},l1,l2,l3,v3[2]={0,0},product,maxproduct;
	G[0]=(double *)malloc(sizeof(double)*(length+2));
	G[1]=(double *)malloc(sizeof(double)*(length+2));
   
	y=(int *)malloc(sizeof(int)*length);
	for (i=0;i<length;i++)
	{
		G[0][i]=g[0][i];
		G[1][i]=g[1][i];
		y[i]=0;		
	}
	G[0][length]=G[0][0];G[1][length]=G[1][0];
	G[0][length+1]=G[0][1];G[1][length+1]=G[1][1];
	/*zcs.   concave partition.
	for(i=0; i<length; i++)
	{
        //find all the concave vertices
		z=(G[0][i+1]-G[0][i])*(G[1][i+2]-G[1][i+1])-(G[1][i+1]-G[1][i])*(G[0][i+2]-G[0][i+1]);
		if(z>0) 
		{
			//concave
            y[count]=i+1;
            if(i==length-1)
                y[count]=0;
			count++;
		}
	}
	*/
	c=count;
	if(!y[0])
	{
        //convex polygon
		fprintf(fp,"  poly m1;rho=1;");
		for(i=0;i<length;i++)
			fprintf(fp,"(%.3f, %.3f), ", G[0][length-i-1], G[1][length-i-1]);
		fprintf(fp,"(%.3f, %.3f)\n", G[0][length-1], G[1][length-1]);
	}
    else
    {
        //if(y[0]==length)
        //    y[0]=0;
        //v1 is the unit vector prior to the concave vertice
        v1[0]=G[0][y[0]-1]-G[0][y[0]];
        v1[1]=G[1][y[0]-1]-G[1][y[0]];
        l1=sqrt(v1[0]*v1[0]+v1[1]*v1[1]);
        v1[0]=v1[0]/l1;
        v1[1]=v1[1]/l1;
        //v2 is the unit vector after the concave vertice
        v2[0]=G[0][y[0]+1]-G[0][y[0]];
        v2[1]=G[1][y[0]+1]-G[1][y[0]];
        l2=sqrt(v2[0]*v2[0]+v2[1]*v2[1]);
        v2[0]=v2[0]/l2;
        v2[1]=v2[1]/l2;
        //v is the vector of the bisector of the concave vertice
        v[0]=-(v1[0]+v2[0]);
        v[1]=-(v1[1]+v2[1]);
        maxproduct=0;
        for(i=0;i<length;i++)
		{
            //v3 is the vector from the concave vertice another vertice in the polygon
            flag=0;
			if(i==y[0]-1||i==y[0]+1||i==y[0])
				continue;
            v3[0]=G[0][i]-G[0][y[0]];
            v3[1]=G[1][i]-G[1][y[0]];
            l3=sqrt(v3[0]*v3[0]+v3[1]*v3[1]);
            product=(v[0]*v3[0]/l3+v[1]*v3[1]/l3);
            if(product>maxproduct)
            {
                //find the vertice closest to v
                //printf("%lf, %d\n",product, i);
                for(j=0;j<length;j++)
                {
                    if(j==y[0]-1||j==y[0]||i==j||j==i-1||i==0&&j==length-1)
                        continue; 
                    // printf("%d,%d,%d\n",i,j,intersect(G[0][y[0]],G[0][i],G[0][j],G[0][j+1],G[1][y[0]],G[1][i],G[1][j],G[1][j+1]));
                    if(intersect(G[0][y[0]],G[0][i],G[0][j],G[0][j+1],G[1][y[0]],G[1][i],G[1][j],G[1][j+1]))
                        flag=1; //v3 intersects with an edge in the polygon. v3 cannot be used as a partitioning line            
                }                
                if(!flag)
                {
                    point=i;
                    maxproduct=product;
                }
            }
        }
        //printf("%d, %d, %d, %lf, %lf,%lf, %lf\n",y[0],point, length, G[0][y[0]],G[1][y[0]],G[0][point],G[1][point]);
          
        min=(point<y[0])?point:y[0];
		max=(point>y[0])?point:y[0];
        //printf("%d, %d\n", y[0],point);
        g1[0]=(double *)malloc(sizeof(double)*(min+length-max+1));
		g1[1]=(double *)malloc(sizeof(double)*(min+length-max+1));
		for(j=0;j<=min;j++)
		{
			g1[0][j]=G[0][j];
			g1[1][j]=G[1][j];
		}
		for(j=max;j<length;j++)
		{
			g1[0][j-max+min+1]=G[0][j];
			g1[1][j-max+min+1]=G[1][j];
		}
		convex(g1,min+length-max+1,fp); //recursion
		free(g1[0]);
		free(g1[1]);
		g1[0]=(double *)malloc(sizeof(double)*(max-min+1));
		g1[1]=(double *)malloc(sizeof(double)*(max-min+1));
		for(j=min; j<=max;j++)
		{
			g1[0][j-min]=G[0][j];
			g1[1][j-min]=G[1][j];
		}		
		convex(g1,max-min+1,fp); //recursion
		free(g1[0]);
		free(g1[1]);        
    }
	free(G[0]);
	free(G[1]);
}		

	
main(int argc, char *argv[])
{
	FILE *fp;
	double *g[2],*G[2],port[2][4],Rtot,x,y,*anglesin, *anglecos,*angle,clockwise=0;
	int count=0,i,j,start;
	char temps[80];
    //printf("%d\n",intersect(-23778945,-23765641,-23780041,-23791783.315,68021,70422,69372,71849.595));
	printf("/*********************************************\n");
    printf("*  Res2d -- A 2D wire resistance calculator  *\n");
    printf("*    for complex-shape wire in FPD or LCD.   *\n");
    printf("*               Version 2014                 *\n");
    printf("*           Copyright Tsinghua Univ.         *\n");
    printf("*********************************************/\n");
	if(argc<2)
	{
		printf("Usage: %s <filename> \n",argv[0]);
		printf("*The executable B2D must be in current dir!\n");
		exit(1);
	}
    if(strcmp(argv[1],"-1")==0)
    {
        fileflag=1;
        printf("fileflag=1\n");
        if((fp=fopen(argv[2],"r"))==NULL)   //load input text.
        {
            printf("Cannot open this file!\n");
            exit(0);
        }
    }
    else
    {
        printf("fileflag=0\nfilename=%s\n", argv[1]);
        if((fp = fopen(argv[1],"r"))==NULL)   //load input text.
        {
            printf("Cannot open this file!\n");
            exit(0);
        }
    }
    for(i=0;i<4;i++)             //The first four lines of the input file indicate the coordinates of the ports
	{
		if(fscanf(fp,"%lf", &port[0][i])!=1){
			printf("error\n");
			exit (1);
		}
		  
		/*
		while(getc(fp)!=',')	//added by yuwj, Aug.2012
			;
			*/
		getc(fp);
		if(fscanf(fp,"%lf", &port[1][i])!=1){
			printf("error\n");
			exit (1);
		}
		//printf("%lf  %lf\n", port[0][i], port[1][i]);
	}
	while(!feof(fp))                        //The rest the coordinates of each vertice of the polygon
	{
		if(fscanf(fp,"%lf",&x)!=1)	//modified by yuwj. Aug. 2012
			break;
		//printf("x=%lf\n", x);
		getc(fp);
		if(fscanf(fp,"%lf",&x)!=1){
			printf("error\n");
			exit (1);
		}
		//printf("x=%lf\n", x);
		count++;
	} 
	printf("Get a polygon with %d vertices\n", count);
	g[0] = (double*)malloc(sizeof(double)*count);
	g[1] = (double*)malloc(sizeof(double)*count);
	count=0;
    rewind(fp);
	for(i=0;i<4;i++)
	{
		if(fscanf(fp,"%lf",&x)!=1){
			printf("error\n");
			exit(1);
		}
		getc(fp);
		if(fscanf(fp,"%lf",&x)!=1){
			printf("error\n");
			exit(1);
		}
	}
	while(!feof(fp))
	{	
		if(fscanf(fp,"%lf",&x)!=1)
			break;
		getc(fp);
		if(fscanf(fp,"%lf",&y)!=1){
			printf("error\n");
			exit(1);
		}
		g[0][count]=x;
		g[1][count]=y;
        if(x==port[0][1]&&y==port[1][1])
            start=count;
		count++;
	}
	fclose(fp);
    anglecos=(double*)malloc(sizeof(double)*count);
    anglesin=(double*)malloc(sizeof(double)*count);
    angle=(double*)malloc(sizeof(double)*count);
	//printf("After reading all data\n");
    //reordering
    for(i=0;i<count;i++)
    {
        if(i==0)
        {
            anglesin[i]=((g[0][i]-g[0][count-1])*(g[1][i+1]-g[1][i])-(g[0][i+1]-g[0][i])*(g[1][i]-g[1][count-1]))/(distance(g[0][i]-g[0][count-1],0,g[1][i]-g[1][count-1],0)*distance(g[0][i+1]-g[0][i],0,g[1][i+1]-g[1][i],0));
            anglecos[i]=((g[0][i]-g[0][count-1])*(g[0][i+1]-g[0][i])+(g[1][i]-g[1][count-1])*(g[1][i+1]-g[1][i]))/(distance(g[0][i]-g[0][count-1],0,g[1][i]-g[1][count-1],0)*distance(g[0][i+1]-g[0][i],0,g[1][i+1]-g[1][i],0));
        }
        else if(i==count-1)
        {
            anglesin[i]=((g[0][i]-g[0][i-1])*(g[1][0]-g[1][i])-(g[0][0]-g[0][i])*(g[1][i]-g[1][i-1]))/(distance(g[0][i]-g[0][i-1],0,g[1][i]-g[1][i-1],0)*distance(g[0][0]-g[0][i],0,g[1][0]-g[1][i],0));
            anglecos[i]=((g[0][i]-g[0][i-1])*(g[0][0]-g[0][i])+(g[1][i]-g[1][i-1])*(g[1][0]-g[1][i]))/(distance(g[0][i]-g[0][i-1],0,g[1][i]-g[1][i-1],0)*distance(g[0][0]-g[0][i],0,g[1][0]-g[1][i],0));
        }   
        else
        {
            anglesin[i]=((g[0][i]-g[0][i-1])*(g[1][i+1]-g[1][i])-(g[0][i+1]-g[0][i])*(g[1][i]-g[1][i-1]))/(distance(g[0][i]-g[0][i-1],0,g[1][i]-g[1][i-1],0)*distance(g[0][i+1]-g[0][i],0,g[1][i+1]-g[1][i],0));
            anglecos[i]=((g[0][i]-g[0][i-1])*(g[0][i+1]-g[0][i])+(g[1][i]-g[1][i-1])*(g[1][i+1]-g[1][i]))/(distance(g[0][i]-g[0][i-1],0,g[1][i]-g[1][i-1],0)*distance(g[0][i+1]-g[0][i],0,g[1][i+1]-g[1][i],0));
        }
        if(anglesin[i]>=0&&anglecos[i]>=0)
            angle[i]=asin(anglesin[i]);
        else if(anglesin[i]>=0&&anglecos[i]<0)
            angle[i]=3.1415926-asin(anglesin[i]);
        else if(anglesin[i]<0&&anglecos[i]<0)
            angle[i]=-3.1415926-asin(anglesin[i]);
        else
            angle[i]=asin(anglesin[i]);
        clockwise+=angle[i];
    }
    G[0] = (double*)malloc(sizeof(double)*count);
    G[1] = (double*)malloc(sizeof(double)*count);
    for(i=0; i<count;i++)
    {   
        if(clockwise>0)
        {
            //counterclockwise, reverse
            G[0][i]=g[0][count-1-i];
            G[1][i]=g[1][count-1-i];
        }
        else
        {
            //clockwise
            G[0][i]=g[0][i];
            G[1][i]=g[1][i];
        }
    }
    //the first vertice of the polygon is the second vertice of the first port
    //the last vertice of the polygon is the first vertice of the first port
    //the order of the vertices in the second port is the same with the order of those vertices in the polygon
    for(i=0; i<count;i++)
    { 
        if(port[0][0]==G[0][i]&&port[1][0]==G[1][i])
        {
            if(i==0&&port[0][1]==G[0][count-1]&&port[1][1]==G[1][count-1])
            {
                port[0][0]=G[0][count-1];
                port[1][0]=G[1][count-1];
                port[0][1]=G[0][i];
                port[1][1]=G[1][i];
                start=i;
            }
            else if(i==count-1&&port[0][1]==G[0][0]&&port[1][1]==G[1][0])
                start=0;
            else if(i>0&&port[0][1]==G[0][i-1]&&port[1][1]==G[1][i-1])
            {
                port[0][0]=G[0][i-1];
                port[1][0]=G[1][i-1];
                port[0][1]=G[0][i];
                port[1][1]=G[1][i];
                start=i;
            }
            else 
                start=i+1;   
            break;
        }
    }
    for(i=0;i<count-start;i++)
    {
        g[0][i]=G[0][i+start];
        g[1][i]=G[1][i+start];
    }
    for(i=count-start;i<count;i++)
    {
        g[0][i]=G[0][i-count+start];
        g[1][i]=G[1][i-count+start];
    }
    for(i=0;i<count;i++)
    {
        if(port[0][2]==g[0][i]&&port[1][2]==g[1][i]&&port[0][3]==g[0][i-1]&&port[1][3]==g[1][i-1])
        {
            port[0][2]=g[0][i-1];
            port[1][2]=g[1][i-1];
            port[0][3]=g[0][i];
            port[1][3]=g[1][i];
            break;
        }
    }
    //print graph after reordering
    /*for(i=0;i<4;i++)
        printf("%lf, %lf\n",port[0][i],port[1][i]);
    for(i=0;i<count;i++)
         printf("%lf, %lf\n",g[0][i],g[1][i]);
    printf("%d, %d, %lf, %lf, %lf, %d\n",LONG, CORNER, ANGLEMIN, ANGLEMAX,clockwise, start);

    */
    //printf("%d\n",intersect(0,1,0,1,0,1,1,0));
	//printf("After reordering!\n");
    longparallel(g, port, count);
	Rtot=r;
    //print the total resistance
	printf("Total resistance is %lf\n", r);
    
}
