#ifndef TYPEH
#define TYPEH
typedef unsigned char BYTE;
typedef unsigned int  WORD;
typedef short Flag;

#define POINTGAP 0.005		//as the min width is about 0.3
#define EPS 1E-9                //for double and double
#define ACCURACY 1E-4           //for point
#define Equal(x,y)      (fabs((x)-(y))<10e-5)
#define Greater(x,y)    (x-y>10e-5)
#define Less(x,y)       (y-x>10e-5)
#define ptEqual(x,y)      (fabs((x)-(y))<POINTGAP)
#define ptGreater(x,y)    (x-y>POINTGAP)
#define ptLess(x,y)       (y-x>POINTGAP)

#define ELES_ON_EDGE 4       //Elements in an edge if default
#define MAX_SHAPE_IN_COPY 4  //Max shape number of source object in copy command
#define INVALIDVOLT -999.0   //Initial volt value of object
#define INVALIDDIEL 0.0      //        diel
#define INVALIDRHO  -1.0	     //		rho
#define PIE 3.1415926535897
#define eps0 8.854187818

typedef short Bool;
#ifndef FALSE
#define FALSE (int)0
#endif
#ifndef TRUE
#define TRUE  (int)1
#endif

//zcs.1211.typedef enum {LINE,ARCEDGE,CURVE} EdgeType;
typedef enum {LINE} EdgeType;
typedef enum {FORCE,NATURAL,BORDER} ElecType;
//zcs.1211.typedef enum {LINELE,ARCELE} EleType;
typedef enum {LINELE} EleType;

#endif
