#include <iostream>
#include <fstream>
#include "type.h"
#include "shape.h"
#include "bem.h"
#include "globalvar.h"

using namespace std;

//zcs.r2d.y
#define SHAPE_MAX 200
#define CONST_MAX  200

	Shell **shell;
	Object **obj;
	int xnum = -1, ynum = -1;
	unsigned short errline;
	const BYTE TOKENLEN = 37;	//sizeof(ReservedWordsList)/sizeof(ReservedWordsList[0]);
	char **constvarlist;
	double *constvaluelist;
	Bool constflag;
	Flag errflg = 0;
	Bool touchflag;
	Bool rhoflag;
	Bool dielflag;
	int shlno, objno;
	char curname[15];
	double tmp1, tmp2;
	Flag *calcarray;
	int *toucharray;
	Object *curobj, *lastobj;
	Shell *curshl;
	Box *curbox;
	Poly *curpoly;
	Points *curpoints;
	int smgno = 0;
	int yylex();
	void initialKeyword();
	Bool isalpha(char);
	Bool isdigit(char);
	int doalpha(ifstream *);
	int dodigit(ifstream *);
	void yyerror(const char *s);
//zcs.2d.c
	char *errmsg = NULL;
	unsigned long errlocate;
	ifstream *tpddlin;  
	int *shapenum;
	unsigned int _edgeCount;  //yuwj added
	Bool autoflag = FALSE;
	Bool divflag = FALSE;
	Bool voltflag = FALSE;
	Bool gaussflag = FALSE;
	Bool blockflag = FALSE;
	Bool capaflag = FALSE;
	Bool fileflag = FALSE;
	Bool induflag = FALSE;
	Bool layerflag = FALSE;
	Bool resiflag = FALSE;
	double static_res = -1;
	int realeles = 0;
//zcs.shapecalc.c
	double maxx, maxy, minx, miny;
	ShellRelation **shellrela;
	ShellRelation *shlrelfield;
	ShellRelation **objectrela;
	ShellRelation *objrelfield;
	Object **condobj;
	Object **medobj;
	char **nametable;
	int medobjnum;				//number of medium object
	int condobjnum;				//number of conductor object
	//these three edge array are formed during calculating
	//When the calculating ended,array EDGE is no use
	double *volt;
	int edgeno;					//Global No. of edge, just a unique No., not a actual num
	Edge **edge, **forceedge, **naturaledge, **borderedge;
	Vert **vert;
	int vertnum, edgenum, forceedgenum, naturaledgenum, borderedgenum;
	int verttotal, edgetotal, forceedgetotal, naturaledgetotal, borderedgetotal;
	int vertrealloc, edgerealloc, forcerealloc, naturalrealloc, borderrealloc;
	Conductor *cond;			//Conductor fit to BEM requirements
	Medium *med;				//Medium which includes conductors and edges
	int condnum;				//Length of conds
	int condno;					//Current conductor number
	int mednum;					//Length of med
//zcs.bem.c
	Bool batchflag;
	int gbvarno;
	int spno;
	double g00[GAUSSTOTAL], gic[GAUSSTOTAL], fa11[GAUSSTOTAL], fa12[GAUSSTOTAL];
	//Xi:[-1,1]  Wi <-->Xi Fai for LinEle
	double ct, dt, mw, ms;

